// TestDriverApp.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#define IOCTL_TESTDRIVER_HIDE_PROCESS CTL_CODE(FILE_DEVICE_UNKNOWN, 0x801, METHOD_NEITHER, FILE_READ_ACCESS | FILE_WRITE_ACCESS)
#define IOCTL_TESTDRIVER_PENDING_USERMODE_REQUEST CTL_CODE(FILE_DEVICE_UNKNOWN, 0x802, METHOD_BUFFERED, FILE_READ_ACCESS | FILE_WRITE_ACCESS)
#define IOCTL_TESTDRIVER_HIDE_PROCESS_ACK CTL_CODE(FILE_DEVICE_UNKNOWN, 0x803, METHOD_BUFFERED, FILE_READ_ACCESS | FILE_WRITE_ACCESS)

const _TCHAR userLink[] = _T("\\\\.\\ProcHider");
HANDLE hProcHider = NULL;

int _tmain(int argc, _TCHAR* argv[])
{
	DWORD BytesReturned = 0;

	_tprintf(_T("Open task manager and verify TestDriverApp is present\nPress any key\n"));

	_gettch();

	hProcHider = CreateFile(
		userLink,
		GENERIC_ALL,
		FILE_SHARE_DELETE | FILE_SHARE_READ | FILE_SHARE_WRITE,
		NULL,
		OPEN_EXISTING,
		0,
		NULL
		);

	if(hProcHider == NULL)
	{
		_tprintf(_T("Error opening ProcHider device handle: 0x%08X\n"),GetLastError());

		_gettch();

		return 0;
	}

	if(DeviceIoControl(
		hProcHider,
		IOCTL_TESTDRIVER_HIDE_PROCESS,
		NULL,
		0,
		NULL,
		0,
		&BytesReturned, //we need this because we have a NULL overlapped structure (MSDN notes), 
						//even if we are not expecting any return bytes
		NULL  //overlapped structure
		))
	{
		_tprintf(_T("Succesfully called IOCTL_TESTDRIVER_HIDE_PROCESS\nCheck Task Manager and verify process is hidden\n"));
	}
	else
	{
		_tprintf(_T("Error calling IOCTL_TESTDRIVER_HIDE_PROCESS: 0x%08X\n"),GetLastError());
	}

	_tprintf(_T("Press any key\n"));

	_gettch();

	CloseHandle(hProcHider);

	return 0;
}

