#include "WinVerifyTrustPend.h"


BOOLEAN bWinVerifyTrustPendInit = FALSE;

LIST_ENTRY WinVerifyPendingIrpListHead = {0};

KSPIN_LOCK WinVerifyPendingIrpListAcces = {0};


BOOLEAN
WinVerifyTrustPendIrp(
	PIRP pIrp
	)
{
	BOOLEAN status = FALSE;

	DbgPrint("TestDriver - PendIrp() - Received a request for pending\n");

	if(pIrp != NULL)
	{
		IoMarkIrpPending(pIrp);

		IoSetCancelRoutine(pIrp,WinVerifyTrustPendIrpCancel); //we set up the IRP cancel routine

		LinkPendingIrpContainer(pIrp);
	}

	status = TRUE;
	
	return(status);
}


/*
PPENDING_IRP
AllocatePendingIrpContainer(
	void
	)
{
	BOOLEAN status = FALSE;
	PPENDING_IRP pPendingIrp = NULL;
	
	pPendingIrp = (PPENDING_IRP)ExAllocatePoolWithTag(
		NonPagedPool,
		sizeof(PENDING_IRP),
		'DNEP'
		);

	if(pPendingIrp != NULL) RtlZeroMemory(pPendingIrp,sizeof(PPENDING_IRP));

	return(pPendingIrp);
}
*/
void
LinkPendingIrpContainer(
	PIRP pIrp
	)
{
	//
	//we atomically insert the Irp in the queue
	//
	ExInterlockedInsertTailList(&WinVerifyPendingIrpListHead,&pIrp->Tail.Overlay.ListEntry,&WinVerifyPendingIrpListAcces);
}

void
WinVerifyTrustPendIrpCancel(
	PDEVICE_OBJECT pDeviceObject,
	PIRP pIrp
	)
{
	KIRQL OldIrql;

	DbgPrint("TestDriver - WinVerifyTrustPendIrpCancel() - Running cancel routine\n");

	IoReleaseCancelSpinLock(pIrp->CancelIrql); //we release the cancel spinlock as per MSDN

	KeAcquireSpinLock(&WinVerifyPendingIrpListAcces,&OldIrql);

	if(!IsListEmpty(&WinVerifyPendingIrpListHead)) 
	{
		if(pIrp->Tail.Overlay.ListEntry.Flink != NULL && pIrp->Tail.Overlay.ListEntry.Blink != NULL)
		{
			//
			//maybe for concurrence the Cancel routine is called right after we were able to complete 
			//a request thus leaving us without anything to cancel
			//
			RemoveEntryList(&pIrp->Tail.Overlay.ListEntry);

			pIrp->Tail.Overlay.ListEntry.Flink = NULL;
			pIrp->Tail.Overlay.ListEntry.Blink = NULL;

			pIrp->IoStatus.Status = STATUS_CANCELLED; //we set the status to STATUS_CANCELLED

			pIrp->IoStatus.Information = 0; //and information of the I/O status block to 0 as per MSDN

			IoCompleteRequest(pIrp, IO_NO_INCREMENT); //and finally complete the Irp
		}
	}

	KeReleaseSpinLock(&WinVerifyPendingIrpListAcces, OldIrql);	

	return;
}

