#include "CEvent.h"

CEvent::CEvent(void)
{

}

CEvent::CEvent(BOOL ManualReset, BOOL InitialState, TCHAR * pName)
{
	Create(ManualReset,InitialState,pName);
}

CEvent::~CEvent(void)
{
	if(IsValid()) CloseHandle(GetObject());

	SetObject(NULL);
}
	
BOOL CEvent::Destroy(void)
{
	if(IsValid())
	{
		CloseHandle(GetObject());

		SetObject(NULL);

		return TRUE;
	}
	return FALSE;
}

BOOL CEvent::Create(BOOL ManualReset, BOOL InitialState, TCHAR * pName)
{
	HANDLE MyObject = NULL;

	if(IsValid()) return FALSE;

	MyObject = CreateEvent(NULL, ManualReset, InitialState, pName);

	if(MyObject == NULL) return FALSE;

	SetObject(MyObject);

	return TRUE;
}

BOOL CEvent::SetEvent(void)
{
	return ::SetEvent(GetObject());
}

DWORD CEvent::Wait(void)
{
	if(!IsValid()) return (DWORD)WAIT_FAILED;

	return WaitForSingleObject(GetObject(),INFINITE);
}

DWORD CEvent::WaitTimeout(DWORD TimeOut)
{
	if(!IsValid()) return (DWORD)WAIT_FAILED;

	return WaitForSingleObject(GetObject(),TimeOut);
}

HANDLE CEvent::GetObject(void)
{
	return(Object);
}

void CEvent::SetObject(HANDLE _Object)
{
	Object = _Object;
}

BOOL CEvent::IsValid(void)
{
	if(GetObject() != NULL) return TRUE;

	return FALSE;
}