#ifndef CTHREAD_H
#define CTHREAD_H

#include <Windows.h>
#include <tchar.h>
#include <strsafe.h>
#include "CCriticalSection.h"
#include "CWaitable.h"

class CThread : public CWaitable
{
	public:
		CThread();
		~CThread();
		BOOL Start(void);
		BOOL Terminate(void);
		BOOL Terminate(DWORD);
		BOOL Suspend(void);
		BOOL Resume(void);
		DWORD Wait(void);
		DWORD WaitTimeout(DWORD);		
		HANDLE GetObject(void);
		
		void SetThreadProc(LPTHREAD_START_ROUTINE _pThreadFunction) { pThreadFunction = _pThreadFunction; };
		LPTHREAD_START_ROUTINE GetThreadProc(void) { return pThreadFunction; };
		void SetThreadpParam(LPVOID _pParameter) { pParameter = _pParameter; };
		LPVOID GetThreadpParam(void) { return pParameter; };
		BOOL IsNull(void);
		BOOL IsFunctionSet(void);
		
		static DWORD WINAPI WrapThreadProc(LPVOID _pparameter);
		
	protected:
	private:
		//method
		HANDLE InternalGetObject(void);
		void SetObject(HANDLE _Object);
		//variable
		LPTHREAD_START_ROUTINE pThreadFunction;
		SECURITY_ATTRIBUTES ThreadAttributes;
		SIZE_T StackSize;
		LPVOID pParameter;
		DWORD CreationFlags;
		DWORD ThreadId;
		HANDLE Object;
		CCriticalSection ThreadSync;		
};

#endif //CTHREAD_H


