#include "WinTrustProxySvcCheckSignature.h"

BOOLEAN
WinTrustProxySvcCheckSignature(
	PWCHAR pFileName//,
	//HANDLE hProcHiderDevice
	)
{
	BOOLEAN status = FALSE;
	WINTRUST_FILE_INFO WinTrustFileInfo = {0};
	GUID ActionGUID = WINTRUST_ACTION_GENERIC_VERIFY_V2; //verify using Authenticode
	WINTRUST_DATA WinTrustData = {0};
	//
	//File we want to verify
	//
	WinTrustFileInfo.cbStruct = sizeof(WINTRUST_FILE_INFO);
	WinTrustFileInfo.pcwszFilePath = pFileName;
	WinTrustFileInfo.hFile = NULL;
	WinTrustFileInfo.pgKnownSubject = NULL;
	//
	//Set data and file info Structure
	//
	WinTrustData.cbStruct = sizeof(WINTRUST_DATA);
	WinTrustData.pFile = &WinTrustFileInfo;
	WinTrustData.dwStateAction = WTD_STATEACTION_IGNORE; //No state action
	WinTrustData.pPolicyCallbackData = NULL; //Default policy provide data
	WinTrustData.pSIPClientData = NULL; //no SIP data
	WinTrustData.dwUIChoice = WTD_UI_NONE; //do not display any User Interface
	WinTrustData.fdwRevocationChecks = WTD_REVOKE_NONE; //do not check revoked cert in the chain
	WinTrustData.dwUnionChoice = WTD_CHOICE_FILE; //the structure is for checking a file
	WinTrustData.hWVTStateData = NULL; //N/A
	WinTrustData.pwszURLReference = NULL; //N/A
	WinTrustData.dwUIContext = 0; //we have no U/I

	switch(
		WinVerifyTrust(
			NULL,
			&ActionGUID,
			&WinTrustData
			)
		)
	{
	case ERROR_SUCCESS:
		//file is signed
		status = TRUE;
		break;
	default:
		break;
	}

	return(status);
}