#ifndef WINSTRUSTPROXYSVC_STRING_HELP_H
#define WINSTRUSTPROXYSVC_STRING_HELP_H

#include "WinTrustProxySvcCommonWinHeader.h"
#include "WinTrustProxySvcCommonHeader.h"

enum STRING_HELP {
	STRING_HELP_NO_ERROR,
	STRING_HELP_CANNOT_ALLOC_RESOURCES,
	STRING_HELP_INVALID_PARAMETER,
	STRING_HELP_STRING_TOO_BIG,
	STRING_HELP_BUFFER_TOO_SMALL,
	STRING_HELP_UNKNOWN_ERROR
};

int 
StringHelpExceptionFilter(
	unsigned int code, 
	struct _EXCEPTION_POINTERS *ep
	);

STRING_HELP 
AllocateStringSpaceForCatSafe(
	TCHAR * pString1, 
	TCHAR * pString2, 
	TCHAR ** ppDestination,  //output
	size_t * pDestSize //output
	);

STRING_HELP 
StringCat(
	TCHAR * pString1,
	TCHAR * pString2, //optional
	TCHAR * pDestination,
	size_t DestSize
	);

STRING_HELP
QuoteString(
	TCHAR * pSource,
	TCHAR ** ppDestination,
	size_t * pDestSize
	);

STRING_HELP 
FreeStringSpace(
	TCHAR * pString
	);

STRING_HELP
AllocateStringSpace(
	TCHAR ** ppSpace,
	size_t SpaceSize
	);


#endif //WINSTRUSTPROXYSVC_STRING_HELP_H